unit Img_Draw;

interface

uses WIndows,kol,Share,Debug;

type
  TDCMode = (dcBitmap,dcHandle,dcContext);

type
  TScale = record
  x,y : Real;
end;

type
  THIImg = class(TDebug)
   public
     fScale,SingleScale      : TScale;
     newwh,newhh,oldwh,oldhh : integer;
     pDC                     : HDC;
     glWnd                   : HWND;
     bmp                     : PBitmap;
     fDrawSource             : TDCMode;
     oldx1,oldy1,oldx2,oldy2 : integer;
     x1,y1,x2,y2             : integer;

     _prop_Point1            : integer;
     _prop_Point2            : integer;
     _prop_Point2AsOffset    : boolean;
     _prop_Size              : integer;
     _prop_Style             : TBrushStyle;
     _prop_Color             : TColor;
     _prop_BgColor           : TColor;
     _prop_Transparent       : boolean;
     _prop_TransparentColor  : TColor;
     _prop_Text              : string;

     _data_Text              : THI_Event;
     _data_Bitmap            : THI_Event;
     _data_SourceBitmap      : THI_Event;
     _data_Size              : THI_Event;
     _data_Color             : THI_Event;
     _data_BgColor           : THI_Event;
     _data_Point1            : THI_Event;
     _data_Point2            : THI_Event;

     _event_onDraw           : THI_Event;

     procedure SetDrawSource(Value:byte);

     property  _prop_DrawSource: byte write SetDrawSource;
     function  imgGetDC(var _Data:TData):boolean;
     procedure imgReleaseDC;
     procedure imgNewSizeDC;

     procedure _work_doDrawSource(var _Data:TData; Index:word);

   protected
    procedure ReadXY(var _Data:TData);
   end;
  
  THIDraw2P = class(THIImg)
   public
     _prop_X                 : integer;
     _prop_Y                 : integer;
     _data_X                 : THI_Event;
     _data_Y                 : THI_Event;
   protected
     procedure ReadXY(var _Data:TData);
   public
  end;

implementation

procedure THIImg.SetDrawSource;
begin
   fDrawSource := TDCMode(Value);
end;

procedure THIImg._work_doDrawSource;
begin
   SetDrawSource(ToInteger(_Data));
end;

procedure THIImg.ReadXY;
var   p:cardinal;
begin
   p := ReadInteger(_Data,_data_Point1,_prop_Point1);
   y1 := p shr 16;
   x1 := p and $FFFF;
   p := ReadInteger(_Data,_data_Point2,_prop_Point2);
   y2 := p shr 16;
   x2 := p and $FFFF;
   if _prop_Point2AsOffset then begin
      inc(x2,x1);
      inc(y2,y1);
   end;
end;

procedure THIDraw2P.ReadXY;
begin
   x1 := ReadInteger(_Data,_data_X,_prop_X);
   y1 := ReadInteger(_Data,_data_Y,_prop_Y);
end;

function THIImg.imgGetDC;
var   DC2: HDC;
begin
  Result := true;
  case fDrawSource of
     dcHandle:  begin
                   glWnd := ReadInteger(_Data,_data_Bitmap,0);
                   pDC := GetDC(glWnd);
                end;
     dcBitmap:  begin
                   bmp := ReadBitmap(_Data,_data_Bitmap,nil);
                   if (bmp <> nil) and (not bmp.Empty) then
                      pDC := bmp.Canvas.Handle
                   else
                      Result := false;
                end;
     dcContext: pDC := ReadInteger(_Data,_data_Bitmap,0);
  end;
  DC2 := GetDC(0);
  fScale.x := GetDeviceCaps(pDC,LOGPIXELSX) / GetDeviceCaps(DC2,LOGPIXELSX);
  fScale.y := GetDeviceCaps(pDC,LOGPIXELSY) / GetDeviceCaps(DC2,LOGPIXELSY);
  SingleScale.x := 1;
  SingleScale.y := 1;
  ReleaseDC(0, DC2);
end;

procedure THIImg.imgReleaseDC;
begin
   case fDrawSource of
      dcHandle: ReleaseDC(glWnd, pDC);
   end;
end;

procedure THIImg.imgNewSizeDC;
begin
   oldx1 := x1;
   oldy1 := y1;
   oldx2 := x2;
   oldy2 := y2;

   oldwh := x2-x1;
   oldhh := y2-y1;

   x1 := Round(x1 * fScale.x);
   y1 := Round(y1 * fScale.y);
   x2 := Round(x2 * fScale.x);
   y2 := Round(y2 * fScale.y);

   newwh := x2-x1;
   newhh := y2-y1;
end;

end.