unit hiImg_Text;

interface

{$I share.inc}

uses Windows,Kol,Share,Img_Draw;

type
  THIImg_Text = class(THIDraw2P)
   private
    GFont: PGraphicTool;
    sFont:TFontRec;
    hMyFont:HFONT;
    procedure TFontToGFont(Font:TFontRec; grFont:PGraphicTool);
    procedure SetNewFont(Value:TFontRec);
   public

    property _prop_Font:TFontRec write SetNewFont;

    destructor Destroy; override;
    procedure _work_doDraw(var _Data:TData; Index:word);
    procedure _work_doFont(var _Data:TData; Index:word);
    procedure _var_TextWidth(var _Data:TData; Index:word);
    procedure _var_TextHeight(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_Text._work_doDraw;
var   dt: TData;
      hOldFont: HFONT;
      OldFontSize: Integer;
      s:string;
begin
   dt := _Data;
TRY
   if not ImgGetDC(_Data) then exit;

   ReadXY(_Data);
   ImgNewSizeDC;

   s := ReadString(_Data,_data_Text,_prop_Text);
   SetBkMode(pDC, TRANSPARENT);
   SetTextColor(pDC, Color2RGB(GFont.Color));   
   OldFontSize := GFont.FontHeight;
   GFont.FontHeight := Round(GFont.FontHeight * fScale.y);
   hMyFont := GFont.Handle;
   hOldFont := SelectObject(pDC, hMyFont);
   TextOut(pDC, x1, y1, PChar(s), length(s));
   SelectObject(pDC, hOldFont);
   GFont.FontHeight := OldFontSize;
   hMyFont := GFont.Handle;

FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw,dt);
END;
end;

procedure THIImg_Text._var_TextWidth;
var   SizeFont: TSize;
      hOldFont: HFONT;
      s: string;
begin
TRY
   if not ImgGetDC(_Data) then exit;
   s := ReadString(_Data,_data_Text,_prop_Text);
   hMyFont := GFont.Handle;
   hOldFont := SelectObject(pDC, hMyFont);
   GetTextExtentPoint32(pDC, PChar(s), Length(s), SizeFont);
   SelectObject(pDC, hOldFont);
   dtInteger(_Data, SizeFont.cx);
FINALLY
   ImgReleaseDC;
END;
end;

procedure THIImg_Text._var_TextHeight;
var   SizeFont: TSize;
      hOldFont: HFONT;
      s: string;
begin
TRY
   if not ImgGetDC(_Data) then exit;
   s := ReadString(_Data,_data_Text,_prop_Text);
   hMyFont := GFont.Handle;
   hOldFont := SelectObject(pDC, hMyFont);
   GetTextExtentPoint32(pDC, PChar(s), Length(s), SizeFont);
   SelectObject(pDC, hOldFont);
   dtInteger(_Data, SizeFont.cy);
FINALLY
   ImgReleaseDC;
END;
end;

destructor THIImg_Text.Destroy;
begin
   if Assigned(GFont) then GFont.free;
   DeleteObject(hMyFont);
   inherited;
end;

procedure THIImg_Text._work_doFont;
begin
   if _IsFont(_Data) then SetNewFont(pfontrec(_Data.idata)^);
end;

procedure THIImg_Text.SetNewFont;
begin
   sFont := Value;
   if Assigned(GFont) then GFont.free;
   GFont := NewFont;
   TFontToGFont(sFont, GFont);
   hMyFont := GFont.Handle;
end;

procedure THIImg_Text.TFontToGFont;
begin
   GrFont.Color:= Font.Color;
   Share.SetFont(GrFont,Font.Style);
   GrFont.FontName:= Font.Name;
   GrFont.FontHeight:= _hi_SizeFnt(Font.Size);
   GrFont.FontCharset:= Font.CharSet;
end;

end.